package dev.shadowsoffire.apotheosis.mixin;

import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.EndlessQuiverEnchant;
import dev.shadowsoffire.apotheosis.Apotheosis;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.ArrowItem;
import org.spongepowered.asm.mixin.Mixin;

@Mixin({ ArrowItem.class })
public class ArrowItemMixin
{
    @Inject(method = { "isInfinite" }, at = { @At("RETURN") }, remap = false, cancellable = true)
    public void apoth_isInfinite(final ItemStack stack, final ItemStack bow, final Player player, final CallbackInfoReturnable<Boolean> ci) {
        if (!ci.getReturnValueZ() && Apotheosis.enableEnch) {
            ci.setReturnValue((Object)((EndlessQuiverEnchant)Ench.Enchantments.ENDLESS_QUIVER.get()).isTrulyInfinite(stack, bow, player));
        }
    }
}
